var Bco01400_RecalculoLancamentoContaCorrente_Controller = function(Bco01400_RecalculoLancamentoContaCorrente_Service, ScreenService, contabilizacaoController) {
  
  var LANC_INVALIDO_CODE = 1;
  var LANC_FORA_DO_PERIODO_CODE = 2;
  
  this.formatFilter = function(widget) {
    
    var currentFilter = widget.appliedFilter.FILTER_ROW;
    var params = {};
    
    params = Bco01400_RecalculoLancamentoContaCorrente_Service.buildParamsAccordingToFilter(currentFilter);
    
    widget.dataSourceFilter = Bco01400_RecalculoLancamentoContaCorrente_Service.buildDataSourceFromParams(params);
  };
  
  this.validateCheckedRow = function(widget) {
    
    var checkedRow = widget.selectedRow;
    
    Bco01400_RecalculoLancamentoContaCorrente_Service.validateCheckedRow(checkedRow).then().catch(function(error) {
      
      if (error.data.messages[0].variables.CODE == LANC_FORA_DO_PERIODO_CODE) {
        ScreenService.showMessage("Lançamento fora do período contábil: __DTINICCTBL__ a __DTFINACCTBL__", null, null, error.data.messages[0].variables);
      } else {
        ScreenService.showMessage("Período contábil inexistente");
      }
      
      unselectRow(widget, checkedRow);
      
    });
    
  };
  
  this.validateCheckedRows = function(widget) {
    
    var checkedRows = widget.dataSource.checkedRows;
    
    Bco01400_RecalculoLancamentoContaCorrente_Service.validateCheckedRows(checkedRows).then(function(response) {
      
      unselectGivenRows(widget, response.dataset.rows_to_be_unchecked);
      
    });
    
    
  };
  
  this.recontabilizarLancamentos = function(widget) {
    
    var checkedRows = widget.dataSource.checkedRows;
    
    Bco01400_RecalculoLancamentoContaCorrente_Service.recontabilizarLancamentos(checkedRows).then(function(success){
      ScreenService.showMessage("Recontabilizacao feita com sucesso.");   
    }).catch(function(error) {
      
      if (contabilizacaoController.checkErrosContabilizacao(error, "Não foi possível realizar todos os lançamentos devido a erros na contablização.")) {
        var message = "Timeout";
        if (error.data.error) {
          message = error.data.error;
        }  
        ScreenService.showMessage(message);
      }
      
    });
    
  };
  
  this.enableTipos = function(widget) {
    
    if (widget.currentRow.P_DEBCRED === 'T') {
      widget.getField('P_TIPOCRED').isVisible = true;
      widget.getField('P_TIPODEB').isVisible = true;
    }
    if (widget.currentRow.P_DEBCRED === 'D') {
      widget.getField('P_TIPOCRED').isVisible = false;
      widget.currentRow.P_TIPOCRED = [];
      widget.getField('P_TIPODEB').isVisible = true;
    }
    if (widget.currentRow.P_DEBCRED === 'C') {
      widget.getField('P_TIPOCRED').isVisible = true;
      widget.getField('P_TIPODEB').isVisible = false;
      widget.P_TIPODEB = [];
    }
    
  };
  
  var unselectRow = function (widget, row) {
    var index = widget.getCheckedRows().indexOf(row);
    widget.dataSource.checkedRows.splice(index, 1);
    row.__isSelected = false;
  };
  
  var unselectGivenRows = function (widget, rows) {
    
    rows.forEach(function(row) {
      
      var removedRow;
      
      widget.dataSource.checkedRows.forEach(function(checkedRow, index, checkedRows) {
        if (checkedRow.NUMERO === row.NUMERO && checkedRow.DEBCRED === row.DEBCRED)
          removedRow = checkedRows.splice(index, 1)[0];
      });
      
      removedRow.__isSelected = false;
      
    });
    
    
  };
  
  
  
};

Configuration(function (ContextRegister){
    ContextRegister.register('Bco01400_RecalculoLancamentoContaCorrente_Controller', Bco01400_RecalculoLancamentoContaCorrente_Controller);
});